unit Win;

interface

{$I share.inc}

uses Kol,{KOLMHToolTip,}Share,ShellAPI,Windows,Messages,Debug,hiHintManager,hiSavePropManager;

type
 THIWin = class(TDebug)
   protected
     Guid:integer;
     NoKill:boolean;
     FParent,Split:PControl;
     OldMes:TOnMessage;
     Ms:TMouseEventData;
     Back:integer; //!!! KeyPreview
     F_event_onPaint:THI_Event;
     hid:pointer;

     procedure KeyDown(Sender: PControl; var Key: Longint; Shift: DWORD); //!!! KeyPreview
     procedure KeyUp(Sender: PControl; var Key: Longint; Shift: DWORD); //!!! KeyPreview
     procedure KeyChar(Sender: PControl; var Key: char; Shift: DWORD); //!!! KeyPreview
     procedure _onKeyDown(Sender: PControl; var Key: Longint; Shift: DWORD);  virtual; //!!! KeyPreview
     procedure _onKeyUp(Sender: PControl; var Key: Longint; Shift: DWORD); virtual; //!!! KeyPreview
     procedure _onKeyChar(Sender: PControl; var Key: char; Shift: DWORD);  virtual; //!!! KeyPreview
     procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); virtual;
     procedure _onMouseMove(Sender: PControl; var Mouse: TMouseEventData); virtual;
     procedure _onMouseEnter( Sender: PObj ); virtual;
     procedure _onMouseLeave( Sender: PObj ); virtual;
     procedure _onMouseUp(Sender: PControl; var Mouse: TMouseEventData); virtual;
     procedure _onMouseWheel(Sender: PControl; var Mouse: TMouseEventData); virtual;//!!!
     function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; virtual;
     procedure _onDblClick(Sender: PControl; var Mouse: TMouseEventData);
     procedure _OnDestroy(Sender:PObj);virtual;
     procedure _onResize(Obj:PObj);virtual;
     procedure _onShow(Obj:PObj); virtual;
     procedure _OnPaint( Sender: PControl; DC: HDC ); virtual;
     procedure SetOnPaint(onPaint:THI_Event);
//     procedure TrackMouseEvnt(Sender :PControl; Flags :DWORD);
//     procedure SetHintManager(hm:IHintManager);
   public
//     t_MouseEvent: TTrackMouseEvent;
     Control:PControl;
     _prop_Left:integer;
     _prop_Top:integer;
     _prop_Width:integer;
     _prop_Height:integer;
     _prop_Align:TControlAlign;
     _prop_TabOrder:integer;
     _prop_Color:TColor;
     _prop_Ctl3D:byte;
     _prop_Hint:string;
     _prop_Font:TFontRec;
     _prop_ParentFont:boolean;
     _prop_Transparent:boolean;
     _prop_Visible:boolean;
     _prop_Enabled:boolean;
     _prop_Cursor:integer;
     _prop_MouseCapture:boolean;
     _prop_Flat:boolean;
     _prop_KeyPreview:boolean; //!!! KeyPreview
     //- Splitter-
      _prop_ModeSp:TNewSpl;
      _prop_SizeSp:integer;
      _prop_ColorSp:TColor;
      _prop_MinOwn:integer;
      _prop_MinRest:integer;
      _prop_HintManager:IHintManager;
      _prop_SavePropManager:ISavePropManager;

     _event_onKeyDown:THI_Event;
     _event_onKeyUp:THI_Event;
     _event_onChar:THI_Event; //!!! KeyPreview
     _event_onMouseDown:THI_Event;
     _event_onMouseMove:THI_Event;
     _event_onMouseUp:THI_Event;
     _event_onMouseWheel:THI_Event;
     _event_onSetFocus:THI_Event;
     _event_onKillFocus:THI_Event;
     _event_onDblClick:THI_Event;
     _event_onResize:THI_Event;
     _event_onShow:THI_Event;

     constructor Create(Parent:PControl);
     destructor Destroy; override;
     procedure Init; virtual;
     procedure _work_doKeyPreview(var Data:TData; Index:word); //!!! KeyPreview
     procedure _work_doVisible(var Data:TData; Index:word);
     procedure _work_doEnabled(var Data:TData; Index:word);
     procedure _work_doHint(var Data:TData; Index:word);
     procedure _work_doLeft(var Data:TData; Index:word);
     procedure _work_doTop(var Data:TData; Index:word);
     procedure _work_doWidth(var Data:TData; Index:word);
     procedure _work_doHeight(var Data:TData; Index:word);
     procedure _work_doColor(var Data:TData; Index:word);
     procedure _work_doCursor(var Data:TData; Index:word);
     procedure _work_doSendToBack(var Data:TData; Index:word);
     procedure _work_doBringToFront(var Data:TData; Index:word);
     procedure _work_doFont(var Data:TData; Index:word);
     procedure _work_doAlign(var Data:TData; Index:word);
     procedure _work_doSetFocus(var Data:TData; Index:word);
     procedure _work_doKeyBack(var Data:TData; Index:word); //!!! KeyPreview
     procedure _var_Handle(var Data:TData; Index:word);
     procedure _var_MouseX(var Data:TData; Index:word);
     procedure _var_MouseY(var Data:TData; Index:word);
     procedure _var_Left(var Data:TData; Index:word);
     procedure _var_Top(var Data:TData; Index:word);
     procedure _var_Width(var Data:TData; Index:word);
     procedure _var_Height(var Data:TData; Index:word);
     procedure _var_Position(var Data:TData; Index:word);
     property _event_onPaint:THI_Event read F_event_onPaint write SetOnPaint;
//     property HintManager:IHintManager read fHintManager write SetHintManager;
 end;

implementation

//-------------------------------------------------------------------------------------------------

function TrackMouseEvent(var EventTrack: TTrackMouseEvent): BOOL; stdcall; external user32 name 'TrackMouseEvent';

//-------------------------------------------------------------------------------------------------
{
procedure THIWin.TrackMouseEvnt;
begin
   t_MouseEvent.cbSize:=SizeOf(TTrackMouseEvent);
   t_MouseEvent.dwFlags:=Flags;
   t_MouseEvent.hwndTrack:=Sender.GetWindowHandle;
   t_MouseEvent.dwHoverTime:=HOVER_DEFAULT;
   TrackMouseEvent(t_MouseEvent);
end;
}

//procedure THIWin.setHintmanager;
//begin
//   if hm <> nil then
//    begin
//      fHintManager := hm;
//      hid := fHintManager.init(Control.GetWindowHandle);
//      fHintManager.hint(hid, _prop_Hint);
//    end;
//end;

constructor THIWin.Create;
begin
   inherited Create;
   FParent := Parent;
   if Parent <> nil then _prop_Color := Parent.Color;
   _prop_Ctl3D := 2;
   _prop_Visible := true;
   _prop_Enabled := true;
   _prop_KeyPreview := true; //!!! KeyPreview
   _prop_MouseCapture := false;
end;

destructor THIWin.Destroy;
begin
   if not NoKill then begin
      Split.Free;
      Control.Visible := false; //for Global_Align(Parent)
      Control.Free;
//    Manager.free;
//    hi.free;
   end;
   inherited;
end;

procedure THIWin._onShow;
begin
   _hi_OnEvent(_event_onShow);
end;

procedure THIWin._OnPaint;
begin
   _hi_OnEvent(F_event_onPaint,integer(Control.Handle));
end;

procedure THIWin.SetOnPaint(onPaint:THI_Event);
begin
   F_event_onPaint := onPaint;
   Control.onPaint := _onPaint;
end;

procedure THIWin._OnDestroy;
begin
   NoKill := true;
end;

procedure THIWin.Init;
var   dt:TData;
begin
   with Control{$ifndef F_P}^{$endif} do begin

      if Assigned(_prop_SavePropManager) then begin
         _prop_SavePropManager.init;
         if Assigned(_prop_SavePropManager) then begin
            dtNull(dt);
            dt := _prop_SavePropManager.sprop('Left', dt, false);
            if not _IsNull(dt) then _prop_Left := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Top', dt, false);
            if not _IsNull(dt) then _prop_Top := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Width', dt, false);
            if not _IsNull(dt) then _prop_Width := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Height', dt, false);
            if not _IsNull(dt) then _prop_Height := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Color', dt, false);
            if not _IsNull(dt) then _prop_Color := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Visible', dt, false);
            if not _IsNull(dt) then _prop_Visible := boolean(ToInteger(dt));
            dt := _prop_SavePropManager.sprop('Enabled', dt, false);
            if not _IsNull(dt) then _prop_Enabled := boolean(ToInteger(dt));
            dt := _prop_SavePropManager.sprop('Cursor', dt, false);
            if not _IsNull(dt) then _prop_Cursor := ToInteger(dt);
            dt := _prop_SavePropManager.sprop('Hint', dt, false);
            if not _IsNull(dt) then _prop_Hint := ToString(dt);
         end;
      end;

      Color := _prop_Color;
      SetPosition(_prop_Left,_prop_Top);
      SetSize(_prop_Width,_prop_Height);
      if _prop_Ctl3D<2 then Ctl3D := _prop_Ctl3D=0;
      Transparent := _prop_Transparent;
      Enabled := _prop_Enabled;
      Cursor := _prop_Cursor;
      if _prop_Flat then
         Style := Style or BS_FLAT;
      if _prop_ParentFont then
         Font.Assign(Parent.Font)
      else begin
         Font.Color := _prop_Font.Color;
         SetFont(Font,_prop_Font.Style);
         Font.FontName :=  _prop_Font.Name;
         Font.FontHeight := _hi_SizeFnt(_prop_Font.Size);
         Font.FontCharset := _prop_Font.CharSet;
      end;

      if _prop_TabOrder > 0 then begin
         Style := Style or WS_TABSTOP;
         LookTabKeys := [tkTab];
         TabOrder := _prop_TabOrder;
      end else
         TabStop := _prop_TabOrder = 0;
      SendToBack;

      OldMes        :=  OnMessage;
      onMouseDown   := _onMouseDown;
      onMouseMove   := _onMouseMove;
      onMouseUp     := _onMouseUp;
      onMouseWheel  := _onMouseWheel;
      OnMouseDblClk := _onDblClick;
      OnMessage     := _onMessage;
      OnDestroy     := _OnDestroy;
      OnKeyDown     := KeyDown; //!!! KeyPreview
      onKeyUp       := KeyUp;   //!!! KeyPreview
      onChar        := KeyChar; //!!! KeyPreview
      onResize      := _onResize;
      onShow        := _onShow;
      onMouseEnter  := _onMouseEnter;
      onMouseLeave  := _onMouseLeave;

      Align := _prop_Align;
      SetWindowPos(GetWindowHandle, HWND_TOP, 0, 0, 0, 0,
                   SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE or SWP_NOOWNERZORDER or SWP_HIDEWINDOW);
      Visible := _prop_Visible;
      CreateWindow;

      if assigned(_prop_ModeSp) then begin
         Split := _prop_ModeSp(FParent,_prop_MinOwn,_prop_MinRest,_prop_ColorSp,_prop_SizeSp);
         case Align of
            caTop,caBottom: Height := Height + _prop_SizeSp + FParent.Border;
            caLeft,caRight: Width := Width + _prop_SizeSp + FParent.Border;
         end;
         Split.Visible := _prop_Visible;
         Split.CreateWindow;
      end;

      if Assigned(_prop_HintManager){ and not IsForm} then begin
         hid := _prop_HintManager.init(GetWindowHandle);
         _prop_HintManager.hint(hid, _prop_Hint);
      end;

   end;
end;

procedure THIWin._onDblClick;
begin
   _hi_OnEvent(_event_onDblClick, integer(Mouse.Button)-1);
end;

procedure THIWin._work_doColor;
var   dt:TData;
begin
   Control.Color := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Color);
      _prop_SavePropManager.sprop('Color', dt, true);
   end;
end;

procedure THIWin._work_doCursor;
var   dt:TData;
begin
   Control.Cursor := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Cursor);
      _prop_SavePropManager.sprop('Cursor', dt, true);
   end;
end;

procedure THIWin._work_doVisible;
var   dt:TData;
begin
   Control.Visible := ReadBool(Data);
   if Split <> nil then Split.Visible := Control.Visible;
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, integer(Control.Visible));
      _prop_SavePropManager.sprop('Visible', dt, true);
   end;
end;

procedure  THIWin._work_doEnabled;
var   dt:TData;
begin
   Control.Enabled := ReadBool(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, integer(Control.Enabled));
      _prop_SavePropManager.sprop('Enabled', dt, true);
   end;
end;

procedure THIWin._work_doHint;
var   dt:TData;
      str:string;
begin
   str := ToString(Data);
   if assigned(_prop_HintManager) then _prop_HintManager.hint(hid, str);
   if Assigned(_prop_SavePropManager) then begin
      dtString(dt, str);
      _prop_SavePropManager.sprop('Hint', dt, true);
   end;
end;

procedure THIWin._work_doLeft;
var   dt:TData;
begin
   Control.Left := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Left);
      _prop_SavePropManager.sprop('Left', dt, true);
   end;
end;

procedure THIWin._work_doTop;
var   dt:TData;
begin
   Control.Top := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Top);
      _prop_SavePropManager.sprop('Top', dt, true);
   end;
end;

procedure THIWin._work_doWidth;
var   dt:TData;
begin
   Control.Width := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Width);
      _prop_SavePropManager.sprop('Width', dt, true);
   end;
end;

procedure THIWin._work_doHeight;
var   dt:TData;
begin
   Control.Height := ToInteger(Data);
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Height);
      _prop_SavePropManager.sprop('Height', dt, true);
   end;
end;

procedure THIWin._work_doSendToBack;
begin
   Control.SendToBack;
end;

procedure THIWin._work_doBringToFront;
begin
   Control.BringToFront;
end;

procedure THIWin._work_doFont;
begin
   if _IsFont(Data) then
      with pfontrec(Data.idata)^ do begin
         Control.Font.Color := Color;
         SetFont(Control.Font,Style);
         Control.Font.FontName :=  Name;
         Control.Font.FontHeight := _hi_SizeFnt(Size);
         Control.Font.FontCharset := CharSet;
      end;
end;

procedure THIWin._work_doAlign;
begin
   Control.Align := TControlAlign(ToInteger(Data));
end;

procedure THIWin._work_doSetFocus;
begin
   Control.Focused := true;
end;

procedure THIWin._var_Handle;
begin
   dtInteger(Data,Control.GetWindowHandle);
end;

procedure THIWin._onMouseDown;
begin
   Ms := Mouse;
   _hi_OnEvent(_event_onMouseDown, integer(Ms.Button)-1);
   if _prop_MouseCapture then begin
      ReleaseCapture;
      SetCapture(Control.Handle);
   end;
end;

procedure THIWin._onMouseMove;
var   b:smallint;
begin
   if assigned(_prop_HintManager) then _prop_HintManager.move(hid, Ms.X, Ms.Y);
   case Ms.Shift of
      1:   b :=  0;
      2:   b :=  1;
      16:  b :=  2;
      else b := -1;
   end;
   Ms := Mouse;
   _hi_OnEvent(_event_onMouseMove, b);
end;

procedure THIWin._onMouseUp;
begin
   Ms := Mouse;
   _hi_OnEvent(_event_onMouseUp, integer(Ms.Button)-1);
   if _prop_MouseCapture then ReleaseCapture;
end;

procedure THIWin._onMouseWheel;
begin
   Ms := Mouse;
   _hi_OnEvent(_event_onMouseWheel, integer(Ms.Shift)div $10000);
end;

procedure THIWin._var_MouseX;
begin
   dtInteger(Data,Ms.X);
end;

procedure THIWin._var_MouseY;
begin
   dtInteger(Data,Ms.Y);
end;

procedure THIWin._var_Left;
begin
   dtInteger(Data,Control.Left);
end;

procedure THIWin._var_Top;
begin
   dtInteger(Data,Control.Top);
end;

procedure THIWin._var_Width;
begin
   dtInteger(Data,Control.Width)
end;

procedure THIWin._var_Height;
begin
   dtInteger(Data,Control.Height)
end;

procedure THIWin._var_Position;
begin
   dtInteger(Data, Control.SelStart);
end;

function THIWin._onMessage;
begin
   case Msg.message of
      WM_SETFOCUS :  _hi_OnEvent(_event_onSetFocus);
      WM_KILLFOCUS:  _hi_OnEvent(_event_onKillFocus);
   end;
   Result := _hi_OnMessage(OldMes,Msg,Rslt);
end;

procedure THIWin._onMouseEnter;
begin
   if assigned(_prop_HintManager) then _prop_HintManager.show(hid);
end;

procedure THIWin._onMouseLeave;
var   dt:TData;
begin
   if assigned(_prop_HintManager) then _prop_HintManager.hide(hid);

   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Left);
      _prop_SavePropManager.sprop('Left', dt, true);
      dtInteger(dt, Control.Top);
      _prop_SavePropManager.sprop('Top', dt, true);
   end;

end;

procedure THIWin._work_doKeyPreview; //!!! KeyPreview
begin
   _prop_KeyPreview := ReadBool(Data);
end;

procedure THIWin._work_doKeyBack; //!!! KeyPreview
begin
   Back := ToInteger(Data);
end;

procedure THIWin.KeyDown; //!!! KeyPreview
begin
   if _prop_KeyPreview and(FParent<> nil)and assigned(FParent.OnKeyDown) then begin
      FParent.OnKeyDown(FParent,Key,Shift);
      if Key=0 then exit;
   end;
   Back := -1;
   _onKeyDown(Sender,Key,Shift);  //virtual
   if Back >= 0 then Key:=Back
   else if Key=0 then Back:=0;
end;

procedure THIWin._onResize;
var   dt:TData;
begin
   if Assigned(_prop_SavePropManager) then begin
      dtInteger(dt, Control.Width);
      _prop_SavePropManager.sprop('Width', dt, true);
      dtInteger(dt, Control.Height);
      _prop_SavePropManager.sprop('Height', dt, true);
   end;

   _hi_OnEvent(_event_onResize);
end;

procedure THIWin._onKeyDown;
begin
   _hi_OnEvent(_event_onKeyDown,Key);
end;

procedure THIWin.KeyUp; //!!! KeyPreview
begin
   if _prop_KeyPreview and(FParent<> nil)and assigned(FParent.OnKeyUp) then begin
      FParent.OnKeyUp(FParent,Key,Shift);
      if Key=0 then exit;
   end;
   Back := -1;
   _onKeyUp(Sender,Key,Shift);  //virtual
   if Back >= 0 then Key:=Back;
end;

procedure THIWin._onKeyUp;
begin
   _hi_OnEvent(_event_onKeyUp,Key);
end;

procedure THIWin.KeyChar; //!!! KeyPreview
begin
   if _prop_KeyPreview and(FParent<> nil)and assigned(FParent.OnChar) then begin
      FParent.OnChar(FParent,Key,Shift);
      if Key=#0 then exit;
   end;
   if Back <> 0 then begin
      Back := -1;
      _onKeyChar(Sender,Key,Shift); //virtual
   end;
   if Back >= 0 then Key:=char(Back);
end;

procedure THIWin._onKeyChar; //!!! KeyPreview
begin
   _hi_OnEvent(_event_onChar,Key+'');
end;

initialization
   DoInitCommonControls(ICC_WIN95_CLASSES);
finalization

end.